
//--------------------------------------------------------------------
//     此代码由T4模板自动生成  byzhouhang 20210918
//	   生成时间 2022-06-07 14:09:29 
//     对此文件的更改可能会导致不正确的行为，并且如果重新生成代码，这些更改将会丢失。
using System;
using IRaCIS.Core.Domain.Share;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Collections.Generic;

namespace IRaCIS.Core.Domain.Models
{
    ///<summary>
    ///VisitTask
    ///</summary>
    [Table("VisitTask")]
    public class VisitTask : Entity, IAuditUpdate, IAuditAdd
    {
      
        public string TaskName { get; set; } = string.Empty;
        public string TaskBlindName { get; set; } = string.Empty;


        //任务来源访视Id  方便回更访视读片状态
        public Guid? SourceSubjectVisitId { get; set; }
        public Guid? SouceReadModuleId { get; set; }
        public ReadingCategory ReadingCategory { get; set; }

       

        public Guid CreateUserId { get; set; }
        public DateTime CreateTime { get; set; }
        public DateTime UpdateTime { get; set; }
        public Guid UpdateUserId { get; set; }
        public Guid TrialId { get; set; }


        /// <summary>
        /// 分配时间
        /// </summary>
        public DateTime? AllocateTime { get; set; }

        public Guid SubjectId { get; set; }


        public int Code { get; set; }

        public string TaskCode { get; set; } = string.Empty;

        public bool IsUrgent { get; set; }

        /// <summary>
        /// 0 代表 单重阅片 产生的任务    否则就是双重  任务 1 任务  2 
        /// </summary>
        [Required]
        public Arm ArmEnum { get; set; }

        //分配状态
        public TaskAllocationState TaskAllocationState { get; set; }


        public TaskState TaskState { get; set; }


        public ReReadingApplyState ReReadingApplyState { get; set; }

        public Guid? DoctorUserId { get; set; }





        [ForeignKey("DoctorUserId")]
        public User DoctorUser { get; set; }

        [ForeignKey("SouceReadModuleId")]
        public ReadModule ReadModule { get; set; }

        [ForeignKey("SourceSubjectVisitId")]
        public SubjectVisit SubjectVisit { get; set; }

        public TaskAllocationRule DoctorTaskAllocationRule { get; set; }

        public TaskMedicalReviewRule DoctorTaskMedicalReviewRule { get; set; }

        [ForeignKey("JudgeVisitTaskId")]
        public VisitTask JudgeVisitTask { get; set; }
        public SubjectUser SujectArm { get; set; }
        public Subject Subject { get; set; }


        //对于裁判项而言，触发裁判的列表
        public List<VisitTask> JudgeVisitList { get; set; }




        //裁判任务的Id
        public Guid? JudgeVisitTaskId { get; set; }

        //任务阅片状态
        public ReadingTaskState ReadingTaskState { get; set; }

        //签名时间
        public DateTime? SignTime { get; set; }

        public DateTime? SuggesteFinishedTime { get; set; }

        //是否是重阅产生的，方便过滤数据
        public bool IsReReadingCreate { get; set; }

        //是否是一致性分析产生
        public bool IsAnalysisCreate { get; set; }

        public string BlindSubjectCode { get; set; } = string.Empty;
        public string BlindTrialSiteCode { get; set; } = string.Empty;



        //一致性分析规则Id  用于最后统计
        public Guid? TaskConsistentRuleId { get; set; }

        /// <summary>
        /// 裁判结果的任务ID
        /// </summary>
        public Guid? JudgeResultTaskId { get; set; }

        [ForeignKey("JudgeResultTaskId")]
        public VisitTask JudgeResultTask { get; set; }

        /// <summary>
        /// 裁判结果的备注
        /// </summary>
        public string JudgeResultRemark { get; set; } = string.Empty;

        //随访任务号   取访视的号  计划外是 访视+0.1   裁判任务在访视任务上+0.002   全局任务在截止访视号上+0.03   肿瘤待定   
        public decimal VisitTaskNum { get; set; }
    }

}
